#include "jngen.h"
#include <iostream>
#include <vector>
#include <string>
#include <deque>

using namespace std;

int main(int argc, char* argv[]) {
	parseArgs(argc, argv);
	
	int n = getOpt(0);
	int m = getOpt(1);
	string t = getOpt(2);
	string die = getOpt(3);
	string place = getOpt(4);
	
    vector<vector<char>> g(n, vector<char>(m, '.'));
	pair<int, int> s, f;
	
	if (place == "rnd") {
		s.first = rnd.next(0, n - 1);
		s.second = rnd.next(0, m - 1);
		f.first = rnd.next(0, n - 1);
		f.second = rnd.next(0, m - 1);
		while (s == f) {
			f.first = rnd.next(0, n - 1);
			f.second = rnd.next(0, m - 1);
		}
	}
	if (place == "ul_dr") {
		s.first = 0;
		s.second = 0;
		f.first = n - 1;
		f.second = m - 1;
	}
	if (place == "ur_dl") {
		s.first = 0;
		s.second = m - 1;
		f.first = n - 1;
		f.second = 0;
	}
	if (place == "dr_ul") {
		s.first = n - 1;
		s.second = m - 1;
		f.first = 0;
		f.second = 0;
	}
	if (place == "dl_ur") {
		s.first = n - 1;
		s.second = 0;
		f.first = 0;
		f.second = m - 1;
	}
	
	if (t == "random") {
		int pt = getOpt(5);
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if (rnd.next(1, 100) <= pt)
					g[i][j] = '#';
	}
	if (t == "rnd_lines") {
		int pt = getOpt(5);
		for (int i = 0; i < n; i++) {
			if (rnd.next(1, 100) <= pt)
				for (int j = 0; j < m; j++)
					g[i][j] = '#';
		}
		for (int j = 0; j < m; j++) {
			if (rnd.next(1, 100) <= pt)
				for (int i = 0; i < n; i++)
					g[i][j] = '#';
		}
	}
	if (t == "snakey_hor") {
		int to = 1;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (i % 3 == 0) {
					if (j > 0 && j < m - 1 && g[i][j - 1] == '.' && g[i][j + 1] == '.')
						g[i][j] = '#';
				}
				else g[i][j] = '#';
			}
			if (i % 3 == 0) to ^= 1;
		}
		if (to) f = make_pair(n - n % 3 - 1, m - 1);
		else f = make_pair(n - n % 3 - 1, 0);
	}
	if (t == "snakey_ver") {
		int to = 1;
		for (int j = 0; j < m; j++) {
			for (int i = 0; i < n; i++) {
				if (j % 3 == 0) {
					if (i > 0 && i < n - 1 && g[i - 1][j] == '.' && g[i + 1][j] == '.')
						g[i][j] = '#';
				}
				else g[i][j] = '#';
			}
			if (j % 3 == 0) to ^= 1;
		}
		if (to) f = make_pair(n - 1, m - m % 3 - 1);
		else f = make_pair(0, m - m % 3 - 1);
	}
	if (t == "destroy_bfs") {
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if (i % 2 == 0 && j % 2 == 1)
					g[i][j] = '#';
	}
	
	g[s.first][s.second] = '.';
	g[f.first][f.second] = '.';
	
    deque<pair<int, int>> q;
    vector<vector<int>> dist(n, vector<int>(m, (int)1e7));
    q.emplace_back(s);
    dist[s.first][s.second] = 0;
    vector<pair<pair<int, int>, int>> moves = {
        { { -1, 0 }, 0 },
        { { 0, -1 }, 0 },
        { { 1, 0 }, 0 },
        { { 0, 1 }, 0 },
        { { -2, 0 }, 1 },
        { { 0, -2 }, 1 },
        { { 2, 0 }, 1 },
        { { 0, 2 }, 1 }
    };
    auto is_in_range = [](int x, int r) {
        return x >= 0 && x < r;
    };
    auto check = [n, m, &g, &is_in_range](pair<int, int> p) {
        return is_in_range(p.first, n) && is_in_range(p.second, m) && g[p.first][p.second] == '.';
    };
    while (!q.empty()) {
        pair<int, int> cur = q.front();
        q.pop_front();
        for (const auto &i : moves) {
            pair<int, int> nxt(cur.first + i.first.first, cur.second + i.first.second);
            if (check(nxt) && dist[nxt.first][nxt.second] > dist[cur.first][cur.second] + i.second) {
                if (i.second) {
                    q.emplace_back(nxt);
                }
                else {
                    q.emplace_front(nxt);
                }
                dist[nxt.first][nxt.second] = dist[cur.first][cur.second] + i.second;
            }
        }
    }
	
	int k = dist[f.first][f.second];
	cout << n << ' ' << m << ' ';
	if (k == 10'000'000) cout << n * m << '\n';
	else if (die == "dead") cout << max(0, k - 1) << '\n';
	else if (t == "destroy_bfs") cout << n * m << '\n';
	else if (die == "alive") cout << k << '\n';
	
	for (int i = 0; i < n; i++, cout << '\n')
		for (int j = 0; j < m; j++)
			cout << g[i][j];
	
	cout << s.first + 1 << ' ' << s.second + 1 << '\n';
	cout << f.first + 1 << ' ' << f.second + 1 << '\n';
	
	return 0;
}