#include "testlib.h"
#include <vector>
#include <algorithm>

using namespace std;

bool dfs(vector <int>& pg, int v, int to_find) {
    while (v != -1) {
        if (v == to_find)
            return false;
        v = pg[v];
    }
    return true;
}

void parse(InStream& stream, int& n, vector <vector <int>>& g, vector <int>& pg) {
	int m = stream.readInt(0, n, "number of moves");
	for (int i = 0; i < m; i++) {
		int from = stream.readInt(1, n - 1, "starting subtree");
		int to = stream.readInt(0, n - 1, "adding to");
		
		g[pg[from]].erase(remove(g[pg[from]].begin(), g[pg[from]].end(), from), g[pg[from]].end());
		if (g[to].size() >= 2)
            stream.quitf(_wa, "can't add %d to allready full vertex %d", from, to);
        if (!dfs(pg, to, from))
            stream.quitf(_wa, "to (%d) can't be lower than from (%d)", to, from);
		
		g[to].push_back(from);
		pg[from] = to;
	}
}

int tnum;
map <vector <int>, int> mp;

int chk(vector <vector <int>>& g, int v = 0) {
	if (g[v].size() == 0) return 1;
	vector <int> cur;
	for (auto to : g[v])
		cur.push_back(chk(g, to));
	sort(cur.begin(), cur.end());
	if (mp[cur] == 0)
		mp[cur] = tnum++;
	return mp[cur];
}

bool is_isomorph(vector <vector <int>>& g1, vector <vector <int>>& g2) {
	tnum = 1;
	mp.clear();
	mp[vector <int>(0)] = tnum++;
	return chk(g1) == chk(g2);
}

int main(int argc, char * argv[]) {
	registerTestlibCmd(argc, argv);
	
	int n = inf.readInt();
	vector <vector <int>> ga(n), gb(n);
	vector <int> pga(n);
	pga[0] = -1;
	for (int i = 1; i < n; i++) {
		int pai = inf.readInt();
		ga[pai].push_back(i);
		pga[i] = pai;
	}
	for (int i = 1; i < n; i++) {
		int pbi = inf.readInt();
		gb[pbi].push_back(i);
	}
	
	auto jg = ga, cg = ga;
	auto jpg = pga, cpg = pga;
	parse(ans, n, jg, jpg);
	if (!is_isomorph(jg, gb)) quitf(_fail, "jury is bad");
	
	parse(ouf, n, cg, cpg);
	if (!is_isomorph(cg, gb)) quitf(_wa, "you are bad");
	
	quitf(_ok, "ok");
	
	return 0;
}