#include "jngen.h"
#include <iostream>
#include <vector>
#include <functional>

using namespace std;

Tree buildRand(int n) {
	if (n == 1) return Tree::random(1);
	auto t = Tree::random(1);
	int l = rnd.next(0, n - 1);
	int r = n - 1 - l;
	if (l > 0) {
	    auto tl = buildRand(l);
		t = t.link(0, tl, 0);
	}
	if (r > 0) {
	    auto tr = buildRand(r);
		t = t.link(0, tr, 0);
	}
	return t;
}

int main(int argc, char* argv[]) {
	parseArgs(argc, argv);
	
	int n = getOpt(0);
	int t = getOpt(1);
	
	cout << n << '\n';
	
	Tree t1, t2;
	
	if (t == 1) {
		t1 = Tree::binary(n);
		t2 = Tree::binary(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	if (t == 2) {
		t1 = Tree::binary(n);
		t2 = Tree::bamboo(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	if (t == 3) {
		t1 = Tree::bamboo(n);
		t2 = Tree::binary(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	if (t == 4) {
		t1 = buildRand(n);
		t2 = Tree::binary(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	if (t == 5) {
		t1 = Tree::binary(n);
		t2 = buildRand(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	if (t == 6) {
		t1 = buildRand(n);
		t2 = buildRand(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	if (t == 7) {
		t1 = buildRand(n);
		t2 = Tree::bamboo(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	if (t == 8) {
		t1 = Tree::bamboo(n);
		t2 = buildRand(n);
		t1.shuffleAllBut({0});
		t2.shuffleAllBut({0});
	}
	
	vector <int> par1(n);
	vector <vector <int>> g1(n);
	for (auto w : t1.edges()) {
		g1[w.first].push_back(w.second);
		g1[w.second].push_back(w.first);
	}
	
	function<void(int, int)> dfs1 = [&](int v, int p) {
		par1[v] = p;
		for (auto to : g1[v])
			if (to != p)
				dfs1(to, v);
	};
	
	vector <int> par2(n);
	vector <vector <int>> g2(n);
	for (auto w : t2.edges()) {
		g2[w.first].push_back(w.second);
		g2[w.second].push_back(w.first);
	}
	
	function<void(int, int)> dfs2 = [&](int v, int p) {
		par2[v] = p;
		for (auto to : g2[v])
			if (to != p)
				dfs2(to, v);
	};
	
	dfs1(0, -1);
	dfs2(0, -1);
	par1.erase(remove(par1.begin(), par1.end(), -1), par1.end());
	par2.erase(remove(par2.begin(), par2.end(), -1), par2.end());
	cout << par1 << '\n';
	cout << par2 << '\n';
	
	return 0;
}